// File _DRAW_3D.cpp
//////////////////////////////////////////////////////////////////////////////
#include "stdafx.h"
#include "_DRAW_3D.h"
//  Z-  

//////////////////////////////////////////////////////////////////////////////
tpzbarr ZB = NULL;

tfloat DrawPspMax = 10;
tfloat DrawPlanePsp = -100;
tfloat DrawPlanePsp2 = DrawPlanePsp * 2;
tfloat DrawPlanePspMax = DrawPlanePsp / (2 * DrawPspMax);
tfloat DrawPlaneClip = -200;
int DrawPlaneClipI = DrawPlaneClip;

tfloat DrawStereoOffs = 0; 

int DrawFog = no;  
tfloat DrawPlaneFogFar = 500;   // ,   
tfloat DrawPlaneFogNear = 0;  // 
tfloat DrawFogDist = DrawPlaneFogFar - DrawPlaneFogNear;  // 
int DrawPlaneFogFarI = DrawPlaneFogFar;  //  
int DrawPlaneFogNearI = DrawPlaneFogNear;
int DrawFogDistI = DrawFogDist + 0.5; 

int DrawRFog = no;  
tfloat DrawPlaneRFogFar = 500;   // ,   
tfloat DrawPlaneRFogNear = 0;  // 
tfloat DrawRFogDist = DrawPlaneRFogFar - DrawPlaneRFogNear;  // 
int DrawPlaneRFogFarI = DrawPlaneRFogFar;  //  
int DrawPlaneRFogNearI = DrawPlaneRFogNear;
int DrawRFogDistI = DrawRFogDist + 0.5; 
tvect DrawRFogPoint = 0;

tfloat DrawNearFadeDist = 5;
int DrawNearFadeDistI = 5;

extern tfloat DrawLimit = 0.5;
extern int DrawLimitI = 1;

int DrawDeepSort = on;
int DrawZBuse = no;
//////////////////////////////////////////////////////////////////////////////
void ZB_Init()
{
  ZB_Done();
  if (DrawZBuse) ZB = (tpzbarr) GetMemAlign(DrawYSZ * DrawXSZ * 4);
};
//////////////////////////////////////////////////////////////////////////////
void ZB_Done()
{
  if (ZB) FreeLMem(ZB);
};
//////////////////////////////////////////////////////////////////////////////
void ZB_Clear()
{
  if (ZB)
   if (DrawXRfull) dwMemSetA16((void *)((unsigned)DrawPTRnear - (unsigned)ImageBits + (unsigned)ZB),0x1f1f1f1f,DrawSZ << 2);
    else { unsigned sz = DrawXR << 2;
           for (int y = 0; y <= DrawYL; y++)
            dwMemSetA16((void *)((unsigned)DrawYptr[y] - (unsigned)ImageBits + (unsigned)ZB),0x1f1f1f1f,sz);
         }; 
  
};
//////////////////////////////////////////////////////////////////////////////
//void DrawSetPspClipPlanes(tfloat pp, tfloat pc)
//{
//  DrawPlanePsp = pp;    
//  DrawPlanePsp2 = DrawPlanePsp * 2;
//  DrawPlanePspMax = 2* DrawPlanePsp / DrawPspMax;
//  if (pc == -1) DrawPlaneClipI = DrawPlaneClip = DrawPlanePsp2 - DrawPlanePspMax;
//  else DrawPlaneClipI = DrawPlaneClip = pc;
//};
void DrawSetPspClipPlanes(tfloat pp, tfloat pc)
{
  DrawPlanePsp = pp;           
  DrawPlanePsp2 = DrawPlanePsp * 2;
  DrawPlanePspMax = DrawPlanePsp2 - DrawPlanePsp / (2 * DrawPspMax);
  if (pc == -1) DrawPlaneClip = DrawPlanePspMax;
  else DrawPlaneClip = pc;
};
//////////////////////////////////////////////////////////////////////////////
void DrawSetFogPlanes(tfloat pfar, tfloat pnear, int dfog)
{
  DrawPlaneFogFar = pfar;
  DrawPlaneFogNear = pnear;
  DrawFogDist = pfar - pnear;
  DrawFog = dfog;
};

//////////////////////////////////////////////////////////////////////////////
void DrawSetRFogPlanes(tfloat pfar, tfloat pnear, int dfog, tvect pfog)
{
  DrawPlaneRFogFar = pfar;
  DrawPlaneRFogNear = pnear;
  DrawRFogDist = pfar - pnear;
  DrawRFog = dfog;
  DrawRFogPoint = pfog;
};

//////////////////////////////////////////////////////////////////////////////
void DrawPrepare()
{
  DrawPlaneClipI = DrawPlaneClip;
  DrawPlaneFogFarI = DrawPlaneFogFar;
  DrawPlaneFogNearI = DrawPlaneFogNear;
  DrawFogDistI = DrawFogDist;
  DrawPlaneRFogFarI = DrawPlaneRFogFar;
  DrawPlaneRFogNearI = DrawPlaneRFogNear;
  DrawRFogDistI = DrawRFogDist;
  DrawNearFadeDistI = DrawNearFadeDist; 
};
//////////////////////////////////////////////////////////////////////////////
////////// //  2D  Z- /////////////////////////////////////////

int DrawDeepZ;
//////////////////////////////////////////////////////////////////////////////
void Draw3D_Init() { Draw2D_Init(); ZB_Init(); }
void Draw3D_Done() { ZB_Done(); Draw2D_Done(); }

//////////////////////////////////////////////////////////////////////////////
/*
void (*D3Dset)();
//////////////////////////////////////////////////////////////////////////////
int *pZB;
void D3Dset_n_Z_n()
{
  pZB=&((*ZB)[DrawOffs]);
  if (DrawDeepZ<*pZB) {*pZB=DrawDeepZ;(*ImageBits)[DrawOffs]=DrawColor;};
}
//////////////////////////////////////////////////////////////////////////////
void D3Dset_B_Z_n()
{
  if (((unsigned)DrawYoffs >= DrawYR) || ((unsigned)DrawXoffs >= DrawXR)) return;
  pZB=&((*ZB)[DrawOffs]);
  if (DrawDeepZ<*pZB) {*pZB=DrawDeepZ;(*ImageBits)[DrawOffs]=DrawColor;};
}
//////////////////////////////////////////////////////////////////////////////
void D3Dset_n_Z_O()
{
  DrawOffsDo();
  pZB=&((*ZB)[DrawOffs]);
  if (DrawDeepZ<*pZB) {*pZB=DrawDeepZ;(*ImageBits)[DrawOffs]=DrawColor;};
}
//////////////////////////////////////////////////////////////////////////////
void D3Dset_B_Z_O()
{
  if (((unsigned)DrawYoffs >= DrawYR) || ((unsigned)DrawXoffs >= DrawXR)) return;
  DrawOffsDo();
  pZB=&((*ZB)[DrawOffs]);
  if (DrawDeepZ<*pZB) {*pZB=DrawDeepZ;(*ImageBits)[DrawOffs]=DrawColor;};
}/**/
//////////////////////////////////////////////////////////////////////////////
tvect DrawCenter = tvect(0,0,0);
tfloat DrawZoom = 1;


//////////////////////////////////////////////////////////////////////////////

